String current_screen;
PImage blue_screen;
PImage dog_screen;
PImage smoothy_screen;
PImage doorbell_screen;

// track mouse state to handle reapeated button presses
Boolean mousePressedLastFrame;

//
String complaint = "";

/**
* Setup 
* Runs once. Similar to a constructor
**/
void setup() {
  size(375,667);
  
  // Load all the backgroupd images
  smoothy_screen = loadImage("2 - Onboarding.png");
  blue_screen = loadImage("1 - Home.png");
  dog_screen = loadImage("dog_screen.jpg");
  doorbell_screen = loadImage("door_bell.jpg");
  current_screen = "start";
  
  // variable to track mouse button state
  mousePressedLastFrame = false;
}

/**
* draw
* Runs in a continuious loop 
**/
void draw() {
  println(""+mouseX+", "+mouseY);
  switch(current_screen) {
     case "start": 
       background(blue_screen);
       if(button_pushed(30,555,315,50)){
         println("WelcomeButtonPressed");
         current_screen = "welcome"; 
       }
       break;
      case "welcome":
        background(smoothy_screen);
       if(button_pushed(30,555,315,50)){
          println("StartButtonPressed");
          current_screen = "doorBell";
      }
        break;
      case "doorBell":
        background(doorbell_screen);
      
        // mouth
       if(button_pushed(88,525,220,35)){
          background(doorbell_screen);
          println("Mouth Pressed");
          textSize(32);
          complaint = "Ouch, thats my mouth";
        }
      
        // eye
       if(button_pushed(110,355,30,30) || 
        button_pushed(240,355,30,30) ){
          background(doorbell_screen);
          println("Mouth Pressed");
          textSize(32);
          complaint = "Ouch, thats my eye"; 
        }
        
        // print the latest complaint
        text(complaint, 10, 30); 
        break;
     default: ;
   }
}

/**
*  button_pushed
* Given position and shape of a button it will respond with 
* true if the button was just pressed, and false otherwise. 
* A press and hold will result in a true on the inital press
* and a false during the hold. 
* 
* Causes the side-effect of highlighting all buttons which can be pressed.
**/
Boolean button_pushed(int x, int y, int w, int h) {
  // Draw a rectangle around all pressable buttons
  // similar to what Figma does
  if(mousePressed){
    pushStyle();
    noFill();
    strokeWeight(4);
    stroke(204, 102, 0);
    rect(x,y,w,h); 
    popStyle();
  }
  
  
  // Check if the mouse clicked this button
  if(mousePressed 
    && mousePressedLastFrame == false 
    && mouseX > x && mouseX < x+w 
    && mouseY > y && mouseY < y+h)
    {
      mousePressedLastFrame = true;
      return true;
    }
 
    // maintain our button pressing state
    if(mousePressed == false){
      mousePressedLastFrame = false;
    }
    
    return false;
}